<id>
Guest Topic View Limit for YaBB 2.5
</id>

<version>
0.1.1
</version>

<mod info>
Description
-----------
This Mod will allow you to set a cookie to limit the amount of topics which guests are allowed to view before they are encouraged to register, either by blocking them from viewing any more topics or by displaying a message at the top of the message view.

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.
3) Go into Admin Center => Forum Settings => Members tab to configure the settings.

Files to edit
-------------
Admin/ModList.pl
Admin/NewSettings.pl
Admin/Settings_Main.pl
Languages/English/Admin.lng
Languages/English/Display.lng
Sources/Display.pl
Templates/default/Display.template
Templates/yabb21/Display.template

Version History
---------------
0.1 - First Release - 23rd April 2012
0.1.1 - Fixed spelling error - 8th May 2012
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://boardmod.org
</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$guest_tvl_mod = "Guest Topic View Limit|Derek Barnstorm|This Mod will allow you to set a cookie to limit the amount of topics which guests are allowed to view before they are encouraged to register, either by blocking them from viewing any more topics or by displaying a message at the top of the message view.|0.1.1|8th May 2012";
	push (@installed_mods, "$guest_tvl_mod");
	
</add before>

<edit file>
Admin/NewSettings.pl
</edit file>

<search for>
\$enable_guestlanguage = $enable_guestlanguage;		# allow browsing guests to select their language - requires more than one language pack! - Set to 0 if do not allow 1 is allow.
</search for>

<add after>
\$enable_guest_view_limit = $enable_guest_view_limit;    # Set to 1 to enable guest topic view limit.
\$guest_view_limit = $guest_view_limit;    # Set the amount of topics guests are allowed to view before they are encouraged to register.
\$guest_view_limit_block = $guest_view_limit_block ;    # Set to 1 to block guests viewing topics if they reach the topic view limit. Set to 0 to display a message at the top of the message view.
</add after>

<edit file>
Admin/Settings_Main.pl
</edit file>

<search for>
$imspam = 0 if $imspam eq 'off';
</search for>

<add after>

$guest_view_limit ||= 15;
</add after>

<search for>
			name => 'guest_media_disallowed',
			validate => 'boolean',
		},
</search for>

<add after>
		{
			description => qq~<label for="enable_guest_view_limit">$admin_txt{'enable_guest_view_limit'}</label>~,
			input_html => qq~<input type="checkbox" name="enable_guest_view_limit" id="enable_guest_view_limit" value="1"${ischecked($enable_guest_view_limit)} />~,
			name => 'enable_guest_view_limit',
			validate => 'boolean',
			depends_on => ['!guestaccess'],
		},
		{
			description => qq~<label for="guest_view_limit">$admin_txt{'guest_view_limit'}</label>~,
			input_html => qq~<input type="text" name="guest_view_limit" id="guest_view_limit" size="5" value="$guest_view_limit" />~,
			name => 'guest_view_limit',
			validate => 'number',
			depends_on => ['enable_guest_view_limit', '!guestaccess'],
		},
		{
			description => qq~<label for="guest_view_limit_block">$admin_txt{'guest_view_limit_block'}</label>~,
			input_html => qq~<input type="checkbox" name="guest_view_limit_block" id="guest_view_limit_block" value="1"${ischecked($guest_view_limit_block)} />~,
			name => 'guest_view_limit_block',
			validate => 'boolean',
			depends_on => ['enable_guest_view_limit', '!guestaccess'],
		},
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
);

%floodtxt = (
</search for>

<add before>
'enable_guest_view_limit' => 'Enable Guest Topic View Limit?<br /><span class="small">Checking this option will set a cookie to limit the amount of topics that guests can view before they are encouraged to register. You can set the amount of topic views and how you want it to behave below.</span>',
'guest_view_limit' => 'Guest Topic View Limit:<br /><span class="small">Set the amount of topics that guests can view before they are encouraged to register.</span>',
'guest_view_limit_block' => 'Block Guests from viewing topics after they have reached the topic view limit?<br /><span class="small">Checking this option will block guests from viewing any more topics after the topic view limit has been reached.<br />Leaving unchecked will display a friendly message at the top of the message view.</span>',
</add before>

<edit file>
Languages/English/Display.lng
</edit file>

<search for>
);

1;
</search for>

<add before>
'guest_message' => 'Guest Message', 
'guest_message_block' => "Hi there Guest,<br /><br />Sorry, but you have exceeded the amount of topics that you are allowed to view as a guest. To view as many topics as you like and to benefit from many more features, why don\'t you <a href=\"$scripturl?action=register\" style=\"font-weight: bold;\">register an account with us</a>. Registration is easy and will only take you a few minutes.<br /><br />If you already have an account with us, then you can <a href=\"$scripturl?action=login\" style=\"font-weight: bold;\">login here</a> to stop seeing this message.<br /><br />Thank you,<br /><br />The $mbname Team",
'guest_message_warn' => "Hi there Guest,<br /><br />It looks like you are enjoying reading our forum, so why don\'t you <a href=\"$scripturl?action=register\" style=\"font-weight: bold;\">register an account with us</a> to stop seeing this message and benefit from many more features. Registration is easy and will only take you a few minutes.<br /><br />If you already have an account with us, then <a href=\"$scripturl?action=login\" style=\"font-weight: bold;\">click here to log in.</a><br /><br />Thank you,<br /><br />The $mbname Team", 
</add before>

<edit file>
Sources/Display.pl
</edit file>

<search for>
	if (&AccessCheck($currentboard, '', $boardperms) ne "granted") { &fatal_error("no_access"); }
</search for>

<add after>

    if ($enable_guest_view_limit && $guestaccess) {
        my $iambot = 0;
        my $user_host = (gethostbyaddr(pack("C4", split(/\./, $user_ip)), 2))[0];	
        if (-e "$vardir/bots.hosts") {
            fopen(BOTS, "$vardir/bots.hosts") || &fatal_error("cannot_open","$vardir/bots.hosts", 1);
            my @botlist = <BOTS>;
            fclose (BOTS);
            chomp(@botlist);
            foreach (@botlist) {
                $_ =~ /(.*?)\|(.*)/;
                $bot_name = $1;
                if ($user_host =~ /$bot_name/i) { $iambot = 1; }
            }
        }
        if ($iamguest && !$iambot && $yyCookies{'yabbviewlimit'} < $guest_view_limit) {
            if ($yyCookies{'yabbviewlimit'}) {
                $gtvlcount = $yyCookies{'yabbviewlimit'};
                $gtvlcount++;
            } else {
                $gtvlcount = 1;
            }
            $yySetCookies1 = &write_cookie(
                -name    => 'yabbviewlimit',
                -value   => $gtvlcount,
                -expires => '+525600m');
        } elsif ($iamguest && !$iambot && $yyCookies{'yabbviewlimit'} >= $guest_view_limit) { 
            if ($guest_view_limit_block) {
                $guest_view_limit_warn = '';
                $yytitle = $display_txt{'guest_message'};
                $yynavigation = qq~&rsaquo; $display_txt{'guest_message'}~;
                $yymain .= qq~
<table cellpadding="4" cellspacing="1" border="0" class="bordercolor" style="margin: 0 auto 5px; width: 100%;">
  <tr>
    <td class="titlebg"><img src="$imagesdir/xx.gif" alt="" border="0" style="vertical-align: middle;"/> $display_txt{'guest_message'}</td>
  </tr>
  <tr>
    <td class="windowbg">
      $display_txt{'guest_message_block'}
    </td>
  </tr>
</table>~;
    &template;
    exit;      
            } else {
                $guest_view_limit_warn = qq~
<table cellpadding="4" cellspacing="1" border="0" class="bordercolor" style="margin: 0 auto 5px; width: 100%;">
  <tr>
    <td class="titlebg"><img src="$imagesdir/xx.gif" alt="" border="0" style="vertical-align: middle;"/> $display_txt{'guest_message'}</td>
  </tr>
  <tr>
    <td class="windowbg">
      $display_txt{'guest_message_warn'}
    </td>
  </tr>
</table>~;
            }
        }
    }
</add after>

<search for>
	$display_template =~ s/({|<)yabb home(}|>)/$template_home/g;
</search for>

<add before>
    $display_template =~ s/({|<)yabb guestview(}|>)/$guest_view_limit_warn/g;
</add before>

<edit file>
Templates/default/Display.template
</edit file>

<search for>
$display_template = qq~
</search for>

<add after>

{yabb guestview}
</add after>

<edit file>
Templates/yabb21/Display.template
</edit file>

<search for>
$display_template = qq~
</search for>

<add after>

<yabb guestview>
</add after>
















